--Check Class
if select(2, UnitClass('player')) ~= "PALADIN" then
    DisableAddOn("HolyPowerIndicator")
    return
end

--Remove Blizzard Frame
PaladinPowerBar:SetAlpha(0)

--Frame
local frame, events = CreateFrame("Frame", "HPI", UIParent), {}
local texture = frame:CreateTexture()
frame:SetMovable()
frame:EnableMouse(false)
frame:SetPoint("CENTER",0, -100)
frame:SetWidth(128)
frame:SetHeight(128)
texture:SetAllPoints(frame)
frame:SetUserPlaced(true)

--Designate Texture (change Alliance to desired texture folder, i.e. Horde, Coins, etc.)
local textureSelect = "Interface\\AddOns\\HolyPowerIndicator\\Number\\"


--Config
HolyPowerIndicator = {};
HolyPowerIndicator.panel = CreateFrame( "Frame", "HolyPowerIndicatorPanel", UIParent );
HolyPowerIndicator.panel.name = "Holy Power Indicator";
InterfaceOptions_AddCategory(HolyPowerIndicator.panel);


LockButton = CreateFrame("CheckButton", "LockButton_GlobalName", HolyPowerIndicator.panel, "ChatConfigCheckButtonTemplate");
LockButton:SetPoint("TOPLEFT", 10, -20);
LockButton_GlobalNameText:SetText("Lock");
LockButton.tooltip = "Locks the indicator frame.";
LockButton:SetChecked(true);
LockButton:SetScript("PostClick", function(self)
    if self:GetChecked() then
        frame:EnableMouse(false)
    else
        frame:EnableMouse(true)
        frame:RegisterForDrag("LeftButton")
        frame:SetScript("OnDragStart", function(self) self:StartMoving() end)
        frame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
         end
end)

local alphaSlider = CreateFrame("Slider", "alphaSlider_GlobalName", HolyPowerIndicator.panel, "OptionsSliderTemplate");
alphaSlider:SetWidth(200);
alphaSlider:SetHeight(20);
alphaSlider:SetPoint("TOPLEFT", 20, -50);
alphaSlider:SetMinMaxValues(0, 1);
alphaSlider:SetValue(1);
alphaSlider:SetValueStep(0.1);
getglobal(alphaSlider:GetName() .. "Low"):SetText("0");
getglobal(alphaSlider:GetName() .. "High"):SetText("1");
getglobal(alphaSlider:GetName() .. "Text"):SetText("5");
alphaSlider_GlobalNameText:SetText("Alpha");
alphaSlider.tooltipText = "Adjusts the frame visibilty.";
alphaSlider:SetScript("OnValueChanged", function(self, value)
    frame:SetAlpha(value)
end)

local scaleSlider = CreateFrame("Slider", "scaleSlider_GlobalName", HolyPowerIndicator.panel, "OptionsSliderTemplate");
scaleSlider:SetWidth(200);
scaleSlider:SetHeight(20);
scaleSlider:SetPoint("TOPLEFT", 20, -100);
scaleSlider:SetMinMaxValues(.1, 2);
scaleSlider:SetValue(1);
scaleSlider:SetValueStep(0.05);
getglobal(scaleSlider:GetName() .. "Low"):SetText(".1");
getglobal(scaleSlider:GetName() .. "High"):SetText("2");
getglobal(scaleSlider:GetName() .. "Text"):SetText("5");
scaleSlider_GlobalNameText:SetText("Scale");
scaleSlider.tooltipText = "Adjusts the frame size.";
scaleSlider:SetScript("OnValueChanged", function(self, value)
    frame:SetScale(value)
end)

local textureMenuFrame = CreateFrame("Frame", "textureMenuFrame", HolyPowerIndicator.panel, "UIDropDownMenuTemplate")
local textureMenuButton = CreateFrame("Button", "textureMenuButton", HolyPowerIndicator.panel, "GameMenuButtonTemplate")

local textureMenuTable = {
    {
        text = "Textures",
        isTitle = 1,
        notCheckable = 1,
    },

    {
        text = "Alliance",
        func = function()
            textureSelect = "Interface\\AddOns\\HolyPowerIndicator\\Alliance\\"
        end,
        checked = function() return textureSelect end,
    },

    {
        text = "Horde",
        func = function()
            textureSelect = "Interface\\AddOns\\HolyPowerIndicator\\Horde\\"
        end,
        checked = function() return textureSelect end,
    },

    {
        text = "Coins",
        func = function()
            textureSelect = "Interface\\AddOns\\HolyPowerIndicator\\Coins\\"
        end,
        checked = function() return textureSelect end,
    },

    {
        text = "BlizzardHP",
        func = function()
            textureSelect = "Interface\\AddOns\\HolyPowerIndicator\\BlizzardHP\\"
        end,
        checked = function() return textureSelect end,
    },

    {
        text = "PvPRank",
        func = function()
            textureSelect = "Interface\\AddOns\\HolyPowerIndicator\\PvPRank\\"
        end,
        checked = function() return textureSelect end,
    },

    {
        text = "Number",
        func = function()
            textureSelect = "Interface\\AddOns\\HolyPowerIndicator\\Number\\"
        end,
        checked = function() return textureSelect end,
    },
}

textureMenuButton:SetText("Textures")
textureMenuButton:SetPoint("TOPLEFT", 50, -150)
textureMenuButton:SetScript("OnClick", function(self, button)
    EasyMenu(textureMenuTable, textureMenuFrame, "textureMenuButton", 0, 0, nil, 10)
end)


--Open Config with slash command
SLASH_HOLYPOWERINDICATOR1 = "/hpi";
function SlashCmdList.HOLYPOWERINDICATOR(msg, editbox)
    InterfaceOptionsFrame_OpenToCategory(HolyPowerIndicator.panel);
end

--Find Holy Power & display count
function events:UNIT_POWER(source,type)
    if source == "player" and type == "HOLY_POWER" then
        local power = UnitPower("player",9)

        if power == 1 then
            texture:SetTexture(textureSelect.."1.tga")
            frame:Show()

        elseif power == 2 then
            texture:SetTexture(textureSelect.."2.tga")
            frame:Show()

        elseif power == 3 then
            texture:SetTexture(textureSelect.."3.tga")
            frame:Show()

        elseif power == 0 then
            frame:Hide()
        end
    end
end

--Register Events
frame:SetScript("OnEvent",function(self,event,...) events[event](self,...) end)

for k,v in pairs(events) do
    frame:RegisterEvent(k)
end